//////Prop Tool//////

datablock ItemData(PropBuilderItem)
{
	category = "Tools";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./propBuilder/toolbox.dts";
	iconName = "./propBuilder/icon";
	colorShiftColor = "1 1 0 1";
	modeMin = 0;
	modeMax = 2;
	UIName = "Prop Tool";
	image = "PropBuilderImage";
	doColorShift = 1;

	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	canDrop = 1;
};

datablock ShapeBaseImageData(PropBuilderImage)
{
	shapeFile = "./propBuilder/toolbox.dts"; //thanks trogtor!
	emap = true;

	colorShiftColor = "1 1 0 1";
	doColorShift = 1;

	mountPoint = 0;
	offset = ".11 0 .1";//"-1.2 .5 -.1";
	eyeOffset = ".65 1.1 -.8";
	eyeRotation = eulerToMatrix("0 0 180");
	rotation = eulerToMatrix("0 0 0"); //"0 0 180");

	correctMuzzleVector = false;
	className = "WeaponImage";

	item = PropBuilderItem;

	ammo = " ";
	melee = true;
	armReady = true;

	stateName[0]						= "Activate";
	stateTimeoutValue[0]				= 0.6;
	stateTransitionOnTimeout[0]			= "Ready";
	stateSequence[0]					= "Equip";
	stateSound[0]						= weaponSwitchSound;
	
	stateName[1]						= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateSequence[1]					= "Ready";
	stateAllowImageChange[1]			= true;
	
	stateName[2]						= "Fire";
	stateTransitionOnTimeout[2]			= "Done";
	stateTimeoutValue[2]				= 0.05;
	stateFire[2]						= true;
	stateAllowImageChange[2]			= false;
	stateEmitter[2]						= brickTrailEmitter;
	stateEmitterNode[2]					= "muzzleNode";
	stateEmitterTime[2]					= 0.05;
	stateScript[2]						= "onFire";
	stateWaitForTimeout[2]				= true;
	
	stateName[3]						= "Done";
	stateAllowImageChange[3]			= false;
	stateTransitionOnTriggerUp[3]		= "Ready";
};

function PropBuilderImage::onFire(%this, %player, %slot)
{
	%dir = vectorNormalize(%player.geteyevector());
	%pos = %player.getEyePoint();
	%end = vectorAdd(%pos, vectorScale(%dir, 7));
	%types = $TypeMasks::FxBrickObjectType | 
				$TypeMasks::StaticShapeObjectType | $TypeMasks::TerrainObjectType;
	%result = containerRaycast(%pos, %end, %types);
	if(!%result)
	{
		return;
	}
	%result = PnP_roundVector(posFromRaycast(%result));

	schedule(33, 0, loadProp_createGhost, %player.client, $PnPsave[%player.client.currProp], %result);
}

////////Prop Hammer////////

datablock ItemData(PropHammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = "./propBuilder/sledgehammer.dts";
	iconName = "";
	colorShiftColor = "1 1 0 1";

	UIName = "Prop Hammer";
	image = "PropHammerImage";
	doColorShift = 0;

	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	canDrop = 1;
};

AddDamageType("PropHammer",	'<bitmap:Add-Ons/Tool_Props/propBuilder/sledge_ci> %1',	'%2 <bitmap:Add-Ons/Tool_Props/propBuilder/sledge_ci> %1',0.75,1);

//effects
datablock ParticleData(propHammerExplosionParticle)
{
	dragCoefficient		= 2;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.1;
	constantAcceleration = 0.0;
	spinSpeed		= 10.0;
	spinRandomMin = -90;
	spinRandomMax = 90;
	lifetimeMS			 = 500;
	lifetimeVarianceMS	= 300;
	textureName			= "base/data/particles/chunk";
	colors[0]	 = "0.7 0.7 0.6 1.0";
	colors[1]	 = "0.9 0.9 0.9 0.0";
	sizes[0]		= 0.4;
	sizes[1]		= 0.2;
};

datablock ParticleData(propHammerExplosionParticle1)
{
	dragCoefficient		= 6;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.1;
	constantAcceleration = 0.0;
	spinRandomMin = -30;
	spinRandomMax = 30;
	lifetimeMS			 = 800;
	lifetimeVarianceMS	= 200;
	textureName			= "base/data/particles/cloud";
	colors[0]	 = "0.6 0.6 0.6 0.2";
	colors[1]	 = "0.7 0.7 0.7 0.0";
	useInvAlpha = true;
	sizes[0]		= 3.2;
	sizes[1]		= 4.6;
};

datablock ParticleEmitterData(propHammerExplosionEmitter)
{
	ejectionPeriodMS = 15;
	periodVarianceMS = 0;
	ejectionVelocity = 4;
	velocityVariance = 0.5;
	ejectionOffset	= 0.0;
	thetaMin			= 0;
	thetaMax			= 120;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "propHammerExplosionParticle";

	uiName = "Prop Hammer Hit";
};

datablock ParticleEmitterData(propHammerExplosionSmokeEmitter)
{
	ejectionPeriodMS = 25;
	periodVarianceMS = 0;
	ejectionVelocity = 4;
	velocityVariance = 0.5;
	ejectionOffset	= 0.0;
	thetaMin			= 0;
	thetaMax			= 120;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "propHammerExplosionParticle1";

	uiName = "Prop Hammer Smoke";
};

datablock ExplosionData(propHammerExplosion)
{
	//explosionShape = "";
	lifeTimeMS = 300;

	soundProfile = hammerHitSound;

	particleEmitter = propHammerExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;

	emitter[0] = propHammerExplosionSmokeEmitter;

	faceViewer	 = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "2.0 2.0 2.0";
	camShakeDuration = 0.5;
	camShakeRadius = 8.0;

	// Dynamic light
	lightStartRadius = 4;
	lightEndRadius = 5;
	lightStartColor = "1.0 1.0 .6 1";
	lightEndColor = "0 0 0 1";
};

datablock ProjectileData(propHammerProjectile)
{
	directDamage		 = 45;
	directDamageType  = $DamageType::PropHammer;
	radiusDamageType  = $DamageType::PropHammer;
	explosion			 = propHammerExplosion;
	//particleEmitter	 = as;

	muzzleVelocity		= 50;
	velInheritFactor	= 1;

	armingDelay			= 0;
	lifetime				= 125;
	fadeDelay			 = 70;
	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= false;
	gravityMod = 0.0;

	brickExplosionRadius = 0.2;
	brickExplosionForce  = 10;
	brickExplosionMaxVolume = 90;
	brickExplosionMaxFloatingVolume = 90;

	hasLight	= false;
	lightRadius = 3.0;
	lightColor  = "0 0 0.5";

	uiName = "Prop Hammer Swing";
};

datablock ShapeBaseImageData(PropHammerImage)
{
	shapeFile = "./propBuilder/sledgehammer.dts"; //thanks trogtor!
	emap = true;

	colorShiftColor = "1 1 0 1";
	doColorShift = 0;

	mountPoint = 0;
	offset = "0 0 0";//"-1.2 .5 -.1";
	eyeOffset = "0 0 0";
	eyeRotation = eulerToMatrix("0 0 0");
	rotation = eulerToMatrix("0 0 0"); //"0 0 180");

	correctMuzzleVector = false;
	className = "WeaponImage";

	item = propHammerItem;
	projectile = propHammerProjectile;
	projectileType = Projectile;

	ammo = " ";
	melee = true;
	doRetraction = false;
	armReady = true;

	stateName[0]						= "Activate";
	stateTimeoutValue[0]				= 0.3;
	stateTransitionOnTimeout[0]			= "Ready";
	stateSequence[0]					= "Equip";
	stateScript[0]							= "onActivate";
	stateSound[0]						= weaponSwitchSound;
	
	stateName[1]						 = "Ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateAllowImageChange[1]		 = true;

	stateName[2]					= "PreFire";
	stateScript[2]						= "onPreFire";
	stateAllowImageChange[2]		 = false;
	stateTimeoutValue[2]				= 0.1;
	stateTransitionOnTimeout[2]	 = "Fire";

	stateName[3]						 = "Fire";
	stateTransitionOnTimeout[3]	 = "StopFire";
	stateTimeoutValue[3]				= 0.2;
	stateFire[3]						 = true;
	stateAllowImageChange[3]		 = false;
	stateSequence[3]					= "Fire";
	stateScript[3]						= "onFire";
	stateWaitForTimeout[3]			= true;
	
	stateName[4]						 = "StopFire";
	stateTransitionOnTimeout[4]	 = "Ready";
	stateTimeoutValue[4]				= 0.4;
	stateAllowImageChange[4]		 = false;
	stateWaitForTimeout[4]			= true;
	stateSequence[4]					= "StopFire";
	stateScript[4]						= "onStopFire";
};

function propHammerImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, shiftaway);
}

function propHammerImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(2,shiftto);
	//is this necessary if not using raycast-based weapons?
	return WeaponImage::onFire(%this, %obj, %slot);
}

function propHammerImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function propHammerImage::onActivate(%this, %obj, %slot)
{
	%obj.playthread(2, plant);
}

////////Package////////

package PropItems{

	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		//lets you pick up multiple proptools if disappear on use is enabled
		if(%col.dataBlock $= "PropBuilderItem" && %col.canPickup && $Server::PnP::propToolUseOnce)
		{
			for(%i=0;%i<%this.maxTools;%i++)
			{
				%item = %obj.tool[%i];
				if(%item $= 0 || %item $= "")
				{
					%freeSlot = 1;
					break;
				}
			}

			if(%freeSlot)
			{
				%obj.pickup(%col);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}

	function PropBuilderImage::onMount(%image, %player, %slot) {
		if(%image == PropBuilderImage.getID()) {
			%client = %player.client;
			%client.currProp = %client.currProp % $PnPSaveCount;

			if ($PnPSaveCount == 0)
				%propName = "No props available";
			else
				%propName = $PnPSave[%client.currProp];

			%client.centerprint("<just:right>\c6 [Right click: Plant] \c4" @ %propName @ "\c6 [Light: Switch]", 99);
			serverCmdCancelBrick(%client);
			%player.playThread(0, "armReadyBoth");
			%player.playThread(2,plant);
		}

		return Parent::onMount(%image, %player, %slot);
	}
	
	function PropBuilderImage::onUnMount(%datablock, %player, %slot) {
		serverCmdCancelBrick(%player.client);
		%player.client.centerprint("",0);
			%player.playThread(0, "root");
		return Parent::onUnMount(%image, %player, %slot);
	}
	
	function servercmdNextSeat(%client) {
		if(%client.player.tool[%client.player.currtool] == PropBuilderItem.getID()) {
			//if (%client.lastSwitchedProps - )

			%client.currProp = (%client.currProp+1) % $PnPSaveCount;

			if ($PnPSaveCount == 0)
				%propName = "No props available";
			else
				%propName = $PnPSave[%client.currProp];

			%client.centerprint("<just:right>\c6 [Right click: Plant] \c4" @ %propName @ "\c6 [Light: Switch]", 99);
			if (isObject(%client.propGGroup))
			{
				%result = getWords(%client.propGGroup.center, 0, 1) SPC %client.propGGroup.minZ;
				loadProp_createGhost(%client, $PnPsave[%client.currProp], %result);
			}
		}
		else
			return Parent::servercmdNextSeat(%client);
	}
	
	function servercmdPrevSeat(%client) {
		if(%client.player.tool[%client.player.currtool] == PropBuilderItem.getID()) {

			%client.currProp = (%client.currProp+$PnPSaveCount-1) % $PnPSaveCount;

			if ($PnPSaveCount == 0)
				%propName = "No props available";
			else
				%propName = $PnPSave[%client.currProp];

			%client.centerprint("<just:right>\c6 [Right click: Plant] \c4" @ %propName @ "\c6 [Light: Switch]", 99);
			if (isObject(%client.propGGroup))
			{
				%result = getWords(%client.propGGroup.center, 0, 1) SPC %client.propGGroup.minZ;
				loadProp_createGhost(%client, $PnPsave[%client.currProp], %result);
			}
		}
		else
			return Parent::servercmdPrevSeat(%client);
	}

	function serverCmdLight(%client)
	{
		if(isObject(%client.propGGroup))
		{
			loadProp_rotateGhost(%client, 1);
		}
		else if(%client.player.tool[%client.player.currtool] == PropBuilderItem.getID()) {
			//if (%client.lastSwitchedProps - )

			%client.currProp = (%client.currProp+1) % $PnPSaveCount;

			if ($PnPSaveCount == 0)
				%propName = "No props available";
			else
				%propName = $PnPSave[%client.currProp];
				
				%client.centerprint("<just:right>\c6 [Right click: Plant] \c4" @ %propName @ "\c6 [Light: Switch]", 99);
			if (isObject(%client.propGGroup))
			{
				%result = getWords(%client.propGGroup.center, 0, 1) SPC %client.propGGroup.minZ;
				loadProp_createGhost(%client, $PnPsave[%client.currProp], %result);
			}
		}
		else
			return Parent::servercmdLight(%client);
	}
};
activatePackage(PropItems);